<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Operands</TITLE>
<link href="suif1_31.html" rel=Next>
<link href="suif1_29.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_29.html">previous</A>, <A HREF="suif1_31.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC30" HREF="suif1_toc.html#TOC30">Operands</A></H2>
<P>
<A NAME="IDX163"></A>

</P>
<P>
<A NAME="IDX164"></A>
Most SUIF instructions have operands that are represented by objects of
the <CODE>operand</CODE> class, which is implemented in the files
<TT>`operand.h'</TT> and <CODE>operand.cc</CODE>.  An operand may have three
different kinds of values:

</P>

<UL>
<LI>

<A NAME="IDX165"></A>
It may be a null operand.  The <CODE>is_null</CODE> method tests for this
case.  Null operands occur when an operand field in an instruction is
unused.

<LI>

<A NAME="IDX166"></A>
<A NAME="IDX167"></A>
<A NAME="IDX168"></A>
An operand may refer directly to the symbol for a variable.  The
<CODE>is_symbol</CODE> method tests for this case.  The <CODE>symbol</CODE> and
<CODE>set_symbol</CODE> methods access the symbol field.  A variable in a
source operand indicates that the contents of the variable are used.  In
a destination operand, a variable is assigned the result of the
instruction.

<LI>

<A NAME="IDX169"></A>
<A NAME="IDX170"></A>
<A NAME="IDX171"></A>
An operand may also point to another instruction.  The <CODE>is_instr</CODE>
method tests for this, and the <CODE>instr</CODE> and <CODE>set_instr</CODE> methods
access the pointer field.  This is used to implement expression trees
and, in low-SUIF, to refer to the results of other instructions in a
flat list.  An instruction pointer in a source operand means that the
result of that instruction is used as the operand.  Conversely, an
instruction pointer in a destination operand indicates that the result
value is used by that instruction.
</UL>

<P>
<A NAME="IDX172"></A>
The <CODE>is_expr</CODE> method is very similar to <CODE>is_instr</CODE>.  Besides
checking if the operand holds an instruction pointer, it also tests if
that instruction is a subexpression that is not contained in a separate
<CODE>tree_instr</CODE> node (i.e. it's not in a flat list).  This method
should not be used for destination operands.

</P>
<P>
Before changing a source operand from an instruction pointer to some
other value, the instruction must be removed.  The <CODE>remove</CODE> method
checks if the operand is an instruction, and if so, calls the
instruction's <CODE>remove</CODE> method.  See section <A HREF="suif1_28.html#SEC28">Source Operands</A>.

</P>
<P>
<A NAME="IDX173"></A>
<A NAME="IDX174"></A>
The operand class includes several methods to simplify common
operations.  One frequently needs to know the type of a particular
operand.  This can be determined from the variable's type or the
instruction's result type, but checking for these different kinds of
operands and then extracting the type is cumbersome.  Instead, you can
use the <CODE>type</CODE> method which performs this operation for you.  It
returns the SUIF <CODE>void</CODE> type for null operands.  Another common
operation is testing an operand to see if it contains an integer
constant from a load constant instruction.  The <CODE>is_const_int</CODE>
method checks if this is the case, and if so, it also returns the value
of the constant.

</P>
<P>
<A NAME="IDX175"></A>
<A NAME="IDX176"></A>
Operands have two different methods for printing themselves out to a
file as text.  The <CODE>print</CODE> method is used by the library when
printing instructions.  Because source and destination operands are
handled differently, <CODE>print</CODE> requires that you specify the
instruction that contains the operand so that it can determine how the
operand is being used.  However, when debugging a program, you may not
know which instruction contains an operand.  If you do know that it is
used as a source operand, you can use the <CODE>print_source</CODE> method to
print it without specifying the instruction.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_29.html">previous</A>, <A HREF="suif1_31.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
